VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTokenizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Text As String
Private m_Separators As Variant
Private m_Tokens() As String
Private m_ChunkSize As Long
Private m_IgnoreEmptyTokens As Boolean
Private m_IncludeSeparators As Variant


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    m_ChunkSize = 10
    Exit Sub
hell:
End Sub
Public Sub Create(ByRef sText As String, seps As Variant)
On Error GoTo hell
    m_Text = sText
    m_Separators = seps
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get ChunkSize() As Long
On Error GoTo hell
    ChunkSize = m_ChunkSize
    Exit Property
hell:
End Property
Public Property Let ChunkSize(ByVal lngChunkSize As Long)
On Error GoTo hell
    ' at least 1
    If lngChunkSize < 1 Then lngChunkSize = 1
    m_ChunkSize = lngChunkSize
    Exit Property
hell:
End Property
Public Property Get IgnoreEmptyTokens() As Boolean
On Error GoTo hell
    IgnoreEmptyTokens = m_IgnoreEmptyTokens
    Exit Property
hell:
End Property
Public Property Let IgnoreEmptyTokens(ByVal blnIgnoreEmptyTokens As Boolean)
On Error GoTo hell
    m_IgnoreEmptyTokens = blnIgnoreEmptyTokens
    Exit Property
hell:
End Property
Public Property Get IncludeSeparators() As Variant
On Error GoTo hell
    IncludeSeparators = m_IncludeSeparators
    Exit Property
hell:
End Property
Public Property Let IncludeSeparators(ByVal vIncludeSeparators As Variant)
On Error GoTo hell
    m_IncludeSeparators = vIncludeSeparators
    Exit Property
hell:
End Property
Public Property Get Text() As String
On Error GoTo hell
    Text = m_Text
    Exit Property
hell:
End Property
Public Property Get Separators() As Variant
On Error GoTo hell
    Separators = m_Separators
    Exit Property
hell:
End Property
Public Property Let Separators(ByVal vSeparators As Variant)
On Error GoTo hell
    m_Separators = vSeparators
    Exit Property
hell:
End Property
Public Property Get Tokens(ByVal index As Long) As String
On Error GoTo hell
    Tokens = m_Tokens(index)
    Exit Property
hell:
End Property
Public Property Get TokenCount() As Long
On Error GoTo hell
    TokenCount = UBound(m_Tokens)
    Exit Property
hell:
End Property


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Sub Execute()
On Error GoTo hell
    ' resize (and clear) array (estimate)
    Dim cChars As Long: cChars = Len(m_Text)
    ReDim m_Tokens(1 To m_ChunkSize)
    ' walk
    Dim iPos As Long, sLastSep As String
    Dim cTokens As Long, iTmp As Long
    Dim iStart As Long: iStart = 1
    Do
        ' test every seperator; use smallest index
        Dim vSep As Variant
        For Each vSep In m_Separators
            iTmp = InStr(iStart, m_Text, CStr(vSep), vbTextCompare)
            If iTmp <> 0 Then
                If iPos = 0 Or iTmp < iPos Then
                    iPos = iTmp
                    sLastSep = CStr(vSep)
                End If
            End If
        Next vSep
        ' more?
        If iPos <> 0 Then
                    ' put in?
                    If m_IgnoreEmptyTokens = False Or iPos - iStart > 0 Then
                        IncCount cTokens
                        m_Tokens(cTokens) = Mid$(m_Text, iStart, iPos - iStart)
                    End If
                    ' include which seps?
                    Dim vInclSep As Variant
                    For Each vInclSep In m_IncludeSeparators
                        If sLastSep = CStr(vInclSep) Then
                            IncCount cTokens
                            m_Tokens(cTokens) = sLastSep
                            Exit For
                        End If
                    Next vInclSep
                    ' advance  ' reset
                    iStart = iPos + Len(sLastSep)
                    iPos = 0: sLastSep = ""
            Else
                    ' put in?
                    If m_IgnoreEmptyTokens = False Or iStart <= cChars Then
                        IncCount cTokens
                        m_Tokens(cTokens) = Mid$(m_Text, iStart)
                    End If
                    ' done
                    Exit Do
        End If
    Loop
    ' shrink array
    ReDim Preserve m_Tokens(1 To cTokens)
    Exit Sub
hell:
End Sub
Private Sub IncCount(ByRef cTokens As Long)
On Error GoTo hell
    cTokens = cTokens + 1
    If cTokens > UBound(m_Tokens) Then
        ReDim Preserve m_Tokens(1 To cTokens + m_ChunkSize)
    End If
    Exit Sub
hell:
End Sub

