VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CXMLNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Name As String
Private m_Parent As CXMLNode
Private m_Nodes As NXMLNodes
Private m_Attributes As NXMLAttributes
Private m_Document As CXMLDocument


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set m_Nodes = New NXMLNodes
    Set m_Attributes = New NXMLAttributes
    Exit Sub
hell:
End Sub
Friend Function CreateFromName(ByVal sName As String) As Boolean
On Error GoTo hell
    ' encaps name
    m_Name = sName
    ' success if name is valid
    If sName <> "" Then
        CreateFromName = True
    End If
    Exit Function
hell:
End Function
Friend Function CreateFromTag(ByVal tag As CXMLTag) As Boolean
On Error GoTo hell
    ' opener or standalone?
    If tag.TagType = ttTwinCloser Then GoTo hell
    ' encaps name
    m_Name = tag.Name
    ' get attributes
    Dim fAttributesOK As Boolean: fAttributesOK = ReadAttributes(tag)
    ' success if attribs && name are valid
    If fAttributesOK And tag.Name <> "" Then
        CreateFromTag = True
    End If
    Exit Function
hell:
End Function
Friend Sub SetParent(ByVal mom As CXMLNode)
On Error GoTo hell
    Set m_Parent = mom
    Exit Sub
hell:
End Sub
Friend Sub SetDocument(ByVal doc As CXMLDocument)
On Error GoTo hell
    Set m_Document = doc
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Name() As String
On Error GoTo hell
    Name = m_Name
    Exit Property
hell:
End Property
Public Property Get Parent() As CXMLNode
On Error GoTo hell
    Set Parent = m_Parent
    Exit Property
hell:
End Property
Public Property Get SubNodes() As NXMLNodes
On Error GoTo hell
    Set SubNodes = m_Nodes
    Exit Property
hell:
End Property
Public Property Get Attributes() As NXMLAttributes
On Error GoTo hell
    Set Attributes = m_Attributes
    Exit Property
hell:
End Property
Public Property Get Document() As CXMLDocument
On Error GoTo hell
    Set Document = m_Document
    Exit Property
hell:
End Property


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Friend Function ToString() As String
On Error GoTo hell
    Dim xa As CXMLAttribute
    ToString = "<" & m_Name
    For Each xa In m_Attributes
        ToString = ToString & " " & xa.ToString
    Next xa
    If m_Nodes.Count > 0 Then
        ToString = ToString & ">"
    Else
        ToString = ToString & "/>"
    End If
    Exit Function
hell:
End Function


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Private Function ReadAttributes(ByVal tag As CXMLTag) As Boolean
On Error GoTo hell
    ' assume success
    Dim fSuccess As Boolean: fSuccess = True
    ' run tokenizer
    Dim t As New CTokenizer
    t.Create tag.Text, Empty
    t.Separators = MXMLGlobals.SpecialChars
    t.IncludeSeparators = MXMLGlobals.SpecialChars
    t.IgnoreEmptyTokens = True
    t.Execute
    ' walk through tokens backwards
    Dim sAttrName As String, sAttrValue As String
    Dim i As Long, sToken As String
    Dim fValue As Boolean
    For i = t.TokenCount To 1 Step -1   ' walk down cos value *may* be empty (name is enough)
        sToken = t.Tokens(i)
        Select Case sToken
            ' quotes are really special
            Case Chr$(34)
                fValue = Not fValue
            ' others (spec. chars are illegal for attrib names; OK in quoted values)
            Case Else
                If fValue = True Then
                        sAttrValue = sToken & sAttrValue
                    ElseIf MXMLGlobals.IsSpecialChar(sToken) = False Then
                        If StrComp(sToken, tag.Name, vbTextCompare) <> 0 Then
                            sAttrName = sToken & sAttrName
                        End If
                End If
        End Select
        ' OK?
        If sAttrName <> "" Then
            sAttrValue = Trim$(sAttrValue)
            sAttrValue = Replace(sAttrValue, Chr$(34), "")
            sAttrValue = Replace(sAttrValue, Chr$(39), "")
            Dim attr As CXMLAttribute
            Set attr = m_Attributes.InsertAt(sAttrName, sAttrValue, 1)
            If Not attr Is Nothing Then
                        attr.SetOwnerNode Me
                Else:   fSuccess = False
            End If
            sAttrName = "": sAttrValue = ""
        End If
    Next i
    ' return success
    ReadAttributes = fSuccess
    Exit Function
hell:
End Function

