VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CXMLTag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Types
Public Enum TagTypeConstants
    ttStandAlone = 0    ' <abc x="5"/>
    ttTwinOpener = 1    ' <p>
    ttTwinCloser = 2    ' </p>
    ttMeta = 3          ' ... what's the right term for <?xml ...>
    ttComment = 4       ' ... check exact syntax
End Enum

' Encaps
Private m_Text As String
Private m_Name As String
Private m_TagType As TagTypeConstants


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Friend Function Create(ByRef sTag As String) As Boolean
On Error GoTo hell
    ' encaps text
    m_Text = sTag
    ' get props (just once for popular props)
    m_TagType = GetTagType(sTag)
    If m_TagType <> ttComment Then
        m_Name = GetTagName(sTag)
    End If
    ' success
    Create = True
    Exit Function
hell:
End Function


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Text() As String
On Error GoTo hell
    Text = m_Text
    Exit Property
hell:
End Property
Public Property Get Name() As String
On Error GoTo hell
    Name = m_Name
    Exit Property
hell:
End Property
Public Property Get TagType() As TagTypeConstants
On Error GoTo hell
    TagType = m_TagType
    Exit Property
hell:
End Property


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Private Function GetTagName(ByRef sTag As String) As String
On Error GoTo hell
    Dim i As Long, iStart As Long, iAfter As Long, sChar As String
    For i = 1 To Len(sTag)
        sChar = Mid$(sTag, i, 1)
        If iStart = 0 Then
                    If MXMLGlobals.IsSpecialChar(sChar) = False Then
                        iStart = i
                    End If
            Else
                    If MXMLGlobals.IsSpecialChar(sChar) = True Then
                        iAfter = i
                        Exit For
                    End If
        End If
    Next i
    If iStart <> 0 And iAfter <> 0 Then
        GetTagName = Mid$(sTag, iStart, iAfter - iStart)
    End If
    Exit Function
hell:
End Function
Private Function GetTagType(ByRef sTag As String) As TagTypeConstants
On Error GoTo hell
    Dim i As Long, sChar As String
    ' closer?
    Dim sFirstNonBlank As String
    For i = 2 To Len(sTag) - 1 ' ignore < && >
        sChar = Mid$(sTag, i, 1)
        If sChar <> Chr$(32) Then
            sFirstNonBlank = sChar
            Exit For
        End If
    Next i
    ' opener / standalone
    Dim sLastNonBlank As String
    For i = Len(sTag) - 1 To 2 Step -1     ' ignore > && <
        sChar = Mid$(sTag, i, 1)
        If sChar <> Chr$(32) Then
            sLastNonBlank = sChar
            Exit For
        End If
    Next i
    ' figure it out
    If sFirstNonBlank = "/" Then
            GetTagType = ttTwinCloser
        ElseIf sFirstNonBlank = "?" Then
            GetTagType = ttMeta
        ElseIf sFirstNonBlank = "!" Then
            GetTagType = ttComment
        ElseIf sLastNonBlank = "/" Then
            GetTagType = ttStandAlone
        Else
            GetTagType = ttTwinOpener
    End If
    Exit Function
hell:
End Function
